#pragma semicolon 1
#pragma tabsize 0

#include <sourcemod>
#include <sdktools>
#include <adminmenu>
#include "dbi.inc"

#define MAX_STEAMID_LENGTH 32
#define MAX_IP_LENGTH 64

#define Prefix "[Offline Ban]"

new Handle:g_Name = INVALID_HANDLE,
	Handle:g_SteamID = INVALID_HANDLE,
	Handle:g_IP = INVALID_HANDLE,
	Handle:g_adminMenu = INVALID_HANDLE,
	Handle:h_Database,
	Handle:h_CvarHostIp,
	Handle:h_CvarPort;
new String:s_ServerIP[32], String:s_ServerPort[8], String:logFile[256],
	String:DatabasePrefix[10] = "sb",
	String:s_Time[32] = "",
	String:s_Target[32] = "";
new bool:sourcebans = false,
	bool:DebugMode = false;
new serverID = -1;

new State:ConfigState;
new Handle:ConfigParser;
enum State /* ConfigState */
{
	ConfigStateNone = 0,
	ConfigStateConfig,
	ConfigStateReasons,
	ConfigStateHacking
}
new Handle:ReasonMenuHandle,
	Handle:HackingMenuHandle;

#define PLUGIN_VERSION "1.0.4"

public Plugin:myinfo = 
{
	name = "Offline Ban list",
	author = "",
	description = "",
	version = PLUGIN_VERSION,
	url = ""
};

public OnPluginStart() 
{
	LoadTranslations("offlineban.phrases");
	
	g_Name = CreateArray(MAX_NAME_LENGTH);
	g_SteamID = CreateArray(MAX_STEAMID_LENGTH);
	g_IP = CreateArray(MAX_IP_LENGTH);
	
	if((ReasonMenuHandle = CreateMenu(ReasonSelected)) != INVALID_HANDLE)
	{
		SetMenuPagination(ReasonMenuHandle, 8);
		SetMenuExitBackButton(ReasonMenuHandle, true);
	}

	if((HackingMenuHandle = CreateMenu(HackingSelected)) != INVALID_HANDLE)
	{
		SetMenuPagination(HackingMenuHandle, 8);
		SetMenuExitBackButton(HackingMenuHandle, true);
	}
	
	new i_Pieces[4], i_LongIP;	
	h_CvarHostIp = FindConVar("hostip");
	h_CvarPort = FindConVar("hostport");
	
	i_LongIP = GetConVarInt(h_CvarHostIp);
	i_Pieces[0] = (i_LongIP >> 24) & 0x000000FF;
	i_Pieces[1] = (i_LongIP >> 16) & 0x000000FF;
	i_Pieces[2] = (i_LongIP >> 8) & 0x000000FF;
	i_Pieces[3] = i_LongIP & 0x000000FF;
	FormatEx(s_ServerIP, sizeof(s_ServerIP), "%d.%d.%d.%d", i_Pieces[0], i_Pieces[1], i_Pieces[2], i_Pieces[3]);
	GetConVarString(h_CvarPort, s_ServerPort, sizeof(s_ServerPort));
    decl String:filename[200];
	BuildPath(Path_SM, logFile, sizeof(logFile), "logs/offlineban.log");
    BuildPath(Path_SM, filename, sizeof(filename), "plugins/sourcebans.smx");
    if (FileExists(filename, false)) 
	{
		SQL_TConnect(GotDatabase, "sourcebans");
		sourcebans = true;
	}
	if(!SQL_CheckConfig("sourcebans"))
	{
		if(ReasonMenuHandle != INVALID_HANDLE)
			CloseHandle(ReasonMenuHandle);
		if(HackingMenuHandle != INVALID_HANDLE)
			CloseHandle(HackingMenuHandle);
		LogToFile(logFile, "Database failure: Could not find Database conf \"sourcebans\". See FAQ: http://sourcebans.net/node/19");
		SetFailState("Database failure: Could not find Database conf \"sourcebans\"");
		return;
	}
}

public OnAllPluginsLoaded()
{
	new Handle:topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != INVALID_HANDLE))
		OnAdminMenuReady(topmenu);
}

public OnMapStart() 
{
	ClearArray(g_Name);
	ClearArray(g_SteamID);
	ClearArray(g_IP);
	ResetSettings();
}

public OnClientPostAdminCheck(client) 
{
	if (!IsClientInGame(client) || IsFakeClient(client)) 
		return;

	decl String:steamID[MAX_STEAMID_LENGTH];
	GetClientAuthString(client, steamID, sizeof(steamID));
	new index = FindStringInArray(g_SteamID, steamID);

	if (index != -1) 
	{
		RemoveFromArray(g_Name, index);
		RemoveFromArray(g_SteamID, index);
		RemoveFromArray(g_IP, index);
	}
}

public OnClientDisconnect(client) 
{
	if (!IsClientInGame(client) || IsFakeClient(client)) 
		return;

	new AdminId:adminId = GetUserAdmin(client);
	if (adminId != INVALID_ADMIN_ID) 
	{
		if (GetAdminImmunityLevel(adminId) > 0) 
			return;
	}

	decl String:buffer[MAX_NAME_LENGTH];
	GetClientName(client, buffer, sizeof(buffer));
	PushArrayString(g_Name, buffer);
	GetClientAuthString(client, buffer, sizeof(buffer));
	PushArrayString(g_SteamID, buffer);
	GetClientIP(client, buffer, sizeof(buffer));
	PushArrayString(g_IP, buffer);
}

public OnLibraryRemoved(const String:name[]) 
{
	if (StrEqual(name, "adminmenu")) 
		g_adminMenu = INVALID_HANDLE;
}

public OnAdminMenuReady(Handle:topmenu)
{
	if (topmenu != g_adminMenu) 
	{
		g_adminMenu = topmenu;
		new TopMenuObject:player_commands = FindTopMenuCategory(g_adminMenu, ADMINMENU_PLAYERCOMMANDS);
		if (player_commands != INVALID_TOPMENUOBJECT)
			AddToTopMenu(g_adminMenu, "OfflineBans", TopMenuObject_Item, AdminMenu_Ban,
				player_commands, "OfflineBans", ADMFLAG_BAN);
	}
}

public AdminMenu_Ban(Handle:topmenu, TopMenuAction:action, TopMenuObject:object_id, param, String:buffer[], maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "OfflineBansTitle", param);
	else if (action == TopMenuAction_SelectOption)
		ShowBanList(param);
}

ShowBanList(client) 
{
	new Handle:menu = CreateMenu(MenuHandler_BanList);
	decl String:title[64];

	Format(title, sizeof(title), "%T", "SelectPlayerTitle", client);
	SetMenuTitle(menu, title);
	decl String:name[MAX_NAME_LENGTH],
		 String:steamID[MAX_STEAMID_LENGTH];
	if (GetArraySize(g_SteamID) == 0)
		PrintToChat(client, "%s %t", Prefix, "No players history");

	for (new i = 0, size = GetArraySize(g_SteamID); i < size; i++) 
	{
		GetArrayString(g_Name, i, name, sizeof(name));
		GetArrayString(g_SteamID, i, steamID, sizeof(steamID));
		AddMenuItem(menu, steamID, name);
	}
	SetMenuExitBackButton(menu, true);

	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_BanList(Handle:menu, MenuAction:action, param1, param2) 
{
	if (action == MenuAction_Select) 
	{
		decl String:steamID[MAX_STEAMID_LENGTH];
		GetMenuItem(menu, param2, steamID, sizeof(steamID));
		strcopy(s_Target, sizeof(s_Target), steamID);
		
		if (DebugMode)
			LogToFile(logFile,": id%i ban - %s", param1, steamID);

		ShowBanTimeMenu(param1);
	}
	else if (action == MenuAction_End) 
		CloseHandle(menu);
	else if (action == MenuAction_Cancel)
	{
		if (param2 == MenuCancel_ExitBack && g_adminMenu != INVALID_HANDLE)
			DisplayTopMenu(g_adminMenu, param1, TopMenuPosition_LastCategory);
	}
}

ShowBanTimeMenu(client) 
{
	new Handle:menu = CreateMenu(MenuHandler_BanTimeMenu);
	decl String:title[100];

	Format(title, sizeof(title), "%T:", "SelectTimeTitle", client);
	SetMenuTitle(menu, title);
	
	if(CheckCommandAccess(client, "sm_unban", ADMFLAG_UNBAN|ADMFLAG_ROOT))
	{	
		Format(title, sizeof(title), "%T", "Permanent", client);
		AddMenuItem(menu, "0", title);
	}
	Format(title, sizeof(title), "%T", "5 minutes", client);
	AddMenuItem(menu, "5", title);
	Format(title, sizeof(title), "%T", "30 minutes", client);
	AddMenuItem(menu, "30", title);
	Format(title, sizeof(title), "%T", "1 hour", client);
	AddMenuItem(menu, "60", title);
	Format(title, sizeof(title), "%T", "1 day", client);
	AddMenuItem(menu, "1440", title);
	Format(title, sizeof(title), "%T", "1 week", client);
	AddMenuItem(menu, "10080", title);
	Format(title, sizeof(title), "%T", "1 month", client);
	AddMenuItem(menu, "43200", title);
	Format(title, sizeof(title), "%T", "3 month", client);
	AddMenuItem(menu, "129600", title);

	SetMenuExitBackButton(menu, true);

	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_BanTimeMenu(Handle:menu, MenuAction:action, param1, param2) 
{
	if (action == MenuAction_Select) 
	{
		decl String:info[32];
		GetMenuItem(menu, param2, info, sizeof(info));
		strcopy(s_Time, sizeof(s_Time), info);
		
		if (DebugMode)
			LogToFile(logFile,": id%i ban time - %s", param1, info);

		DisplayMenu(ReasonMenuHandle, param1, MENU_TIME_FOREVER);
	}
	else if (action == MenuAction_End) 
		CloseHandle(menu);
	else if (action == MenuAction_Cancel)
		ShowBanList(param1);
}


public ReasonSelected(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		decl String:info[128];
		decl String:key[128];
		GetMenuItem(menu, param2, key, sizeof(key), _, info, sizeof(info));
		
		if (DebugMode)
			LogToFile(logFile,": id%i ban reasen - %s", param1, key);
			
		if(StrEqual("Hacking", key))
		{
			DisplayMenu(HackingMenuHandle, param1, MENU_TIME_FOREVER);
			return;
		}
		CreateBan(param1, key);	
	}
	else if (action == MenuAction_Cancel)
		ShowBanTimeMenu(param1);
}

public HackingSelected(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		decl String:info[128];
		decl String:key[128];
		GetMenuItem(menu, param2, key, sizeof(key), _, info, sizeof(info));
		
		if (DebugMode)
			LogToFile(logFile,": id%i ban reasen - %s", param1, key);
		
		CreateBan(param1, key);	
	}
	else if (action == MenuAction_Cancel)
		DisplayMenu(ReasonMenuHandle, param1, MENU_TIME_FOREVER);
}

stock CreateBan(client, String:reason[])
{
	decl String:steamID[MAX_STEAMID_LENGTH],
		 String:name[MAX_NAME_LENGTH],
		 String:ip[MAX_IP_LENGTH];
		 
	 new time = StringToInt(s_Time);
		 
	if (DebugMode)
		LogToFile(logFile,": Target(%s) - time(%i) - reason(%s)", s_Target, time, reason);
		
	new index = FindStringInArray(g_SteamID, s_Target);
	GetArrayString(g_Name, index, name, sizeof(name));
	GetArrayString(g_IP, index, ip, sizeof(ip));

	GetClientAuthString(client, steamID, sizeof(steamID));

	if (sourcebans)
	{
		if( serverID == -1 )
		{
			new String:s_Query[1024];
			FormatEx(s_Query, sizeof(s_Query), "INSERT INTO sb_bans (ip, authid, name, created, ends, length, reason, aid, adminIp, sid, country) VALUES \
				('%s', '%s', '%s', UNIX_TIMESTAMP(), UNIX_TIMESTAMP() + %d, %d, '%s', \
				(SELECT `aid` FROM %s_admins WHERE `authid` = '%s' LIMIT 0,1), '%s', \
				(SELECT `sid` FROM %s_servers WHERE `ip` = '%s' AND `port` = '%s' LIMIT 0,1), ' ')", 
				ip, s_Target, name, (time*60), (time*60), reason, DatabasePrefix, steamID, s_ServerIP, DatabasePrefix, s_ServerIP, s_ServerPort);
				SQL_TQuery(h_Database, VerifyInsert, s_Query, 0, DBPrio_High);
				if (DebugMode)
					LogToFile(logFile,": %s", s_Query);
		}
		else
		{
			new String:s_Query[1024];
			FormatEx(s_Query, sizeof(s_Query), "INSERT INTO sb_bans (ip, authid, name, created, ends, length, reason, aid, adminIp, sid, country) VALUES \
				('%s', '%s', '%s', UNIX_TIMESTAMP(), UNIX_TIMESTAMP() + %d, %d, '%s', \
				(SELECT `aid` FROM %s_admins WHERE `authid` = '%s' LIMIT 0,1), '%s', \
				%d, ' ')", ip, s_Target, name, (time*60), (time*60), reason, DatabasePrefix, steamID, s_ServerIP, serverID);
				SQL_TQuery(h_Database, VerifyInsert, s_Query, 0, DBPrio_High);
				if (DebugMode)
					LogToFile(logFile,": %s", s_Query);
		}
		PrintToChat(client, "%s %t", Prefix, "Added to ban", s_Target);
	}
	else
		ServerCommand("sm_addban %i \"%s\" \"%s\"", time, s_Target, reason);

	RemoveFromArray(g_Name, index);
	RemoveFromArray(g_SteamID, index);
	RemoveFromArray(g_IP, index);

	return true;
}

public GotDatabase(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE)
	{
		LogToFile(logFile, "Database failure: %s", error);
		return;
	}
	
	h_Database = hndl;

	decl String:s_Query[1024];
	FormatEx(s_Query, sizeof(s_Query), "SET NAMES `utf8`");

	SQL_TQuery(h_Database, ErrorCheckCallback, s_Query);
}

public ErrorCheckCallback(Handle:owner, Handle:hndle, const String:error[], any:data)
{
	if(error[0])
		LogToFile(logFile, "Query Failed: %s", error);
}

public VerifyInsert(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if (hndl == INVALID_HANDLE || error[0])
	{
		LogToFile(logFile, "Verify Insert Query Failed: %s", error);
		return;
	}
}

static InitializeConfigParser()
{
	if (ConfigParser == INVALID_HANDLE)
	{
		ConfigParser = SMC_CreateParser();
		SMC_SetReaders(ConfigParser, ReadConfig_NewSection, ReadConfig_KeyValue, ReadConfig_EndSection);
	}
}

static InternalReadConfig(const String:path[])
{
	ConfigState = ConfigStateNone;

	new SMCError:err = SMC_ParseFile(ConfigParser, path);

	if (err != SMCError_Okay)
	{
		decl String:buffer[64];
		if (SMC_GetErrorString(err, buffer, sizeof(buffer)))
		{
			PrintToServer(buffer);
			LogToFile(logFile, buffer);
		}
		else 
		{
			PrintToServer("Fatal parse error");
			LogToFile(logFile, "Fatal parse error");
		}
	}
}

public SMCResult:ReadConfig_NewSection(Handle:smc, const String:name[], bool:opt_quotes)
{
	if(name[0])
	{
		if(strcmp("Config", name, false) == 0)
			ConfigState = ConfigStateConfig;
		else if(strcmp("BanReasons", name, false) == 0)
			ConfigState = ConfigStateReasons;
		else if(strcmp("HackingReasons", name, false) == 0)
			ConfigState = ConfigStateHacking;
	}
	return SMCParse_Continue;
}

public SMCResult:ReadConfig_KeyValue(Handle:smc, const String:key[], const String:value[], bool:key_quotes, bool:value_quotes)
{
	if(!key[0])
		return SMCParse_Continue;

	switch(ConfigState)
	{
		case ConfigStateConfig:
		{
			if(strcmp("DatabasePrefix", key, false) == 0) 
			{
				strcopy(DatabasePrefix, sizeof(DatabasePrefix), value);

				if(DatabasePrefix[0] == '\0')
					DatabasePrefix = "sb";
			}
			else if(strcmp("ServerID", key, false) == 0)
				serverID = StringToInt(value);
		}
		case ConfigStateReasons:
		{
			if(ReasonMenuHandle != INVALID_HANDLE)
				AddMenuItem(ReasonMenuHandle, key, value);
		}
		case ConfigStateHacking:
		{
			if(HackingMenuHandle != INVALID_HANDLE)
				AddMenuItem(HackingMenuHandle, key, value);
		}
	}
	return SMCParse_Continue;
}

public SMCResult:ReadConfig_EndSection(Handle:smc)
{
	return SMCParse_Continue;
}

stock ReadConfig()
{
	InitializeConfigParser();

	if (ConfigParser == INVALID_HANDLE)
		return;

	decl String:ConfigFile[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, ConfigFile, sizeof(ConfigFile), "configs/sourcebans/sourcebans.cfg");

	if(FileExists(ConfigFile))
	{
		InternalReadConfig(ConfigFile);
		PrintToServer("%s Loading configs/sourcebans.cfg config file", Prefix);
	} 
	else 
	{
		decl String:Error[PLATFORM_MAX_PATH + 64];
		FormatEx(Error, sizeof(Error), "%sFATAL *** ERROR *** can not find %s", Prefix, ConfigFile);
		LogToFile(logFile, "FATAL *** ERROR *** can not find %s", ConfigFile);
		SetFailState(Error);
	}
}

stock ResetSettings()
{
	ResetMenu();
	ReadConfig();
}

stock ResetMenu()
{
	if(ReasonMenuHandle != INVALID_HANDLE)
		RemoveAllMenuItems(ReasonMenuHandle);
}
